﻿using System;
using System.Configuration;
using System.ServiceModel;
using System.Threading;

namespace Srv
{
	class Program
	{
		static void Main(string[] args)
		{
			var host = new ServiceHost(typeof(HelloWorldService));
			host.Open();
			Console.ReadLine();
			host.Close();
		}
	}

	[ServiceContract]
	public interface IHelloWorldService
	{
		[OperationContract]
		string HelloWorld(string name);
	}

	[ServiceBehavior(ConcurrencyMode = ConcurrencyMode.Multiple, InstanceContextMode = InstanceContextMode.PerCall)]
	public class HelloWorldService : IHelloWorldService
	{
		public static readonly Random R = new Random();
		public static int Cmpt = 0;

		public string HelloWorld(string name)
		{
			Interlocked.Increment(ref Cmpt);
			try
			{
				Console.WriteLine("Input {0:mm:ss.fff} Cmpt={1}", DateTime.Now, Cmpt);
				int i = Convert.ToBoolean(ConfigurationManager.AppSettings["RunningModeRandom"]) ? R.Next(1000, 10000) : 3000;
				Thread.Sleep(i);
				return string.Format("Hello {0}. I slept for {1} ms", name, i);
			}
			finally
			{
				Interlocked.Decrement(ref Cmpt);
			}
		}

	}
}
